#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/org_maachang_mailslot_NativeMailSlot.h"

#pragma comment(lib,"jvm.lib")

// [Xbgnh.
static HANDLE hmail = NULL ;

// [f[^i[IuWFNg.
typedef struct {
	unsigned char* value ;
	unsigned int length ;
} MAIL_DATA,*LPMAIL_DATA ;

// [f[^i[̏.
inline void initMailData( LPMAIL_DATA o ) {
	o->value = NULL ;
	o->length = 0 ;
}

// [f[^j.
inline void deleteMailData( LPMAIL_DATA o ) {
	if( o->value != NULL ) {
		free( o->value ) ;
		o->value = NULL ;
	}
	o->length = 0 ;
}

// [f[^𐶐.
inline void createMailData( LPMAIL_DATA o,int length ) {
	deleteMailData( o ) ;
	o->value = ( unsigned char* )malloc( length+1 ) ;
	memset( o->value,'\0',length+1 ) ;
	o->length = length ;
}

// [Xbg.
inline int initMailSlot( char* name ) {
	char nsp[ 1024 ] ;
	sprintf( nsp,"\\\\.\\mailslot\\%s\0",name ) ;
	hmail =  CreateMailslot( nsp,0,0,NULL ) ;
	if( hmail == INVALID_HANDLE_VALUE ) {
		return -1 ;
	}
	return 0 ;
}

// [XbgI.
inline void destroyMailSlot() {
	if( hmail != NULL ) {
		CloseHandle( hmail ) ;
		hmail = NULL ;
	}
}

// [Xbgf[^M.
inline int receiveMailSlot( LPMAIL_DATA out ) {
	unsigned long msgs ;
	unsigned long dataLen ;
	unsigned long readLen ;
	// f[^⍇.
	if( !GetMailslotInfo( hmail,0,&dataLen,&msgs,NULL) ) {
		return -1 ;
	}
	// bZ[W݂.
	if( msgs ) {
		createMailData( out,dataLen ) ;
		ReadFile( hmail,out->value,dataLen,&readLen,NULL );
		// f[^Ԃ.
		return readLen ;
	}
	return 0 ;
}

// [XbgɃf[^M.
inline int sendMailSlot( char* comp,char* name,LPMAIL_DATA in ) {
	char nsp[ 1024 ] ;
	if( comp == NULL || strlen( comp ) == 0 ) {
		sprintf( nsp,"\\\\.\\mailslot\\%s\0",name ) ;
	}
	else {
		sprintf( nsp,"\\\\%s\\mailslot\\%s\0",comp,name ) ;
	}
	HANDLE h = CreateFile(nsp,GENERIC_WRITE,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL );
	if( h  == INVALID_HANDLE_VALUE ) {
		return -1 ;
	}
	unsigned long writeLen ;
	WriteFile( h,in->value,in->length,&writeLen,NULL ) ;
	CloseHandle( h ) ;
	h = NULL ;
	return 0 ;
}

///////////////////////////////////////////////////////////////////////////////
// JNI.
///////////////////////////////////////////////////////////////////////////////

// [Xbg.
JNIEXPORT jint JNICALL Java_org_maachang_mailslot_NativeMailSlot_initMailSlot
  (JNIEnv* env, jobject o, jbyteArray name) {
	jboolean b ;
	jbyte* nm=(*env).GetByteArrayElements(name,&b);
	int ret = initMailSlot( ( char* )nm ) ;
	(*env).ReleaseByteArrayElements(name,nm,0);
	return ret ;
}

// [XbgI.
JNIEXPORT void JNICALL Java_org_maachang_mailslot_NativeMailSlot_destroyMailSlot
  (JNIEnv* env, jobject o) {
	destroyMailSlot() ;
}

// [XbgM.
JNIEXPORT jbyteArray JNICALL Java_org_maachang_mailslot_NativeMailSlot_receiveMailSlot
  (JNIEnv* env, jobject o) {
	MAIL_DATA dt ;
	initMailData( &dt ) ;
	int res = receiveMailSlot( &dt ) ;
	if( res > 0 ) {
		jboolean b ;
		jbyteArray jret = env->NewByteArray(dt.length);
		jbyte* ret = (*env).GetByteArrayElements(jret,&b);
		memset(ret,'\0',dt.length) ;
		memcpy(ret,dt.value,dt.length) ;
		deleteMailData(&dt) ;
		(*env).ReleaseByteArrayElements(jret,ret,0);
		return jret ;
	}
	return NULL ;
}

// w胁[Xbgɏ񑗐M.
JNIEXPORT void JNICALL Java_org_maachang_mailslot_NativeMailSlot_sendMailSlot
  (JNIEnv* env, jobject o, jbyteArray comp, jbyteArray name, jbyteArray data) {
	jboolean b ;
	jbyte* cmp=(*env).GetByteArrayElements(comp,&b);
	jbyte* nm=(*env).GetByteArrayElements(name,&b);
	jbyte* dt=(*env).GetByteArrayElements(data,&b);
	int len = strlen((char*)dt) ;
	MAIL_DATA md ;
	initMailData(&md);
	createMailData(&md,len);
	memcpy(md.value,dt,len);
	sendMailSlot((char*)cmp,(char*)nm,&md);
	deleteMailData(&md) ;
	(*env).ReleaseByteArrayElements(comp,cmp,0);
	(*env).ReleaseByteArrayElements(name,nm,0);
	(*env).ReleaseByteArrayElements(data,dt,0);
}
